//
//  Generator.m
//  Async
//
//  Created by Kenneth Ballenegger on 2008/04/05.
//  Copyright 2008 Azure Talon. All rights reserved.
//

#import "Generator.h"
#import <SSCrypto/SSCrypto.h>

@implementation Generator

-(IBAction)generate:(id)sender
{
	NSData *privateKeyData = [NSData dataWithContentsOfURL:[NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"private" ofType:@"pem"]]];
	NSData *publicKeyData = [NSData dataWithContentsOfURL:[NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"public" ofType:@"pem"]]];
	NSString *details = [NSString stringWithFormat:@"%@+%@", [name stringValue], [email stringValue]];
	
	SSCrypto *crypto = [[SSCrypto alloc] initWithPublicKey:publicKeyData privateKey:privateKeyData];
	[crypto setClearTextWithString:details];
	
	NSData *signedTextData = [crypto sign];
	NSString *string = [signedTextData encodeBase64WithNewlines:NO];
	
	[serial setStringValue:string];
	
	[crypto release];
}

@end
