//
//  Validator.m
//  Async
//
//  Created by Kenneth Ballenegger on 2008/04/05.
//  Copyright 2008 Azure Talon. All rights reserved.
//

#import "Validator.h"
#import <SSCrypto/SSCrypto.h>

@implementation Validator

-(IBAction)validate:(id)sender
{
	NSData *publicKeyData = [NSData dataWithContentsOfURL:[NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"public" ofType:@"pem"]]];
	NSString *details = [NSString stringWithFormat:@"%@+%@", [name stringValue], [email stringValue]];
	NSData *number = [[[serial stringValue] dataUsingEncoding:NSUTF8StringEncoding] decodeBase64WithNewLines:NO];
	
	SSCrypto *crypto = [[SSCrypto alloc] initWithPublicKey:publicKeyData];
	[crypto setCipherText:number];
	
	[crypto verify];
	
	if([[crypto clearTextAsString] isEqualToString:details])
		NSRunAlertPanel(@"Result", @"Good serial!", @"OK", nil, nil);
	else
		NSRunAlertPanel(@"Result", @"Wrong serial!", @"OK", nil, nil);
	
	[crypto release];
}

@end
